<template>
  <div>
    <stripe-elements
      ref="elementsRef"
      :pk="publishableKey"
      :amount="price"
      locale="fr"
      @token="tokenCreated"
      @loading="loading = $event"
    >
    </stripe-elements>
    <v-btn 
      color="blue" 
      class="mb-2 mb-sm-0 ml-2" 
      style="color: white; width: 30%;"
      @click="submit">
      <v-icon style="text-decoration: none;">mdi-cash-register</v-icon> Payer {{price}}€
    </v-btn>
  </div>
</template>
 
<script>
import { StripeElements } from 'vue-stripe-checkout';
import { mapActions } from 'vuex';
import { mapFields } from 'vuex-map-fields';
import NotificationMixin from '../../mixins/NotificationMixin';

export default {
  name: 'PaymentShow',
  mixins:[NotificationMixin],
  components: {
    StripeElements
  },
  data: () => ({
    loading: false,
    publishableKey: "pk_test_51GznX6EHr3IFn40OYNj8L94SnVVu22pXSJIbYaG0P9RFptGlDFtmGSvupQnVREgOpzEDqKjnGlJ8KyrMvPr4Mhj100K8O9J2Ng", 
    token: null
  }),
  computed: {
    ...mapFields('payment', {paymentValidated: 'paymentValidated'}),
  },
  props: {
    price: {
      type: Number
    },
    cart: {
      type: Array
    },
  },
  watch: {
    paymentValidated (newData){
      if(newData){
        this.toggleCartLoaded(false);
        this.$router.push({name: 'profileOrders',params:{id:this.cart.products.cartReference}});
      }
    },
  },
  methods: {
    ...mapActions('payment', ['sendCharge']),
    ...mapActions('cart', ['toggleCartLoaded']),
    submit () {
      this.$refs.elementsRef.submit();
    },
    tokenCreated (token) {
      this.token = token;
      this.sendCharge({token: this.token.id, cart: this.cart});
      this.showMessage('Paiement effectué' , 'success');
    },
  }
}
</script> 
